package struts.action;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import struts.dao.DaoPerson;
import struts.dao.DaoSeminar;
import struts.form.FormPerson;
import struts.vo.VoPerson;
import struts.vo.VoSeminar;

public class ActionPerson extends BaseAction {
	
	@Override
	public ActionForward performTask(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		
		FormPerson f = (FormPerson) form;
		
		DaoPerson daoPerson = new DaoPerson();
		DaoSeminar daoSeminar = new DaoSeminar();
		
		// 사람 등록
		if("regist".equals(f.getQuery())) {
			daoPerson.insertPerson(f.getRegName(), f.getRegGender());
			f.setRegName("");
			f.setRegGender("");
		}
		
		// 사람 삭제
		if("delete".equals(f.getQuery())) {
			daoPerson.deletePerson(f.getSeq());
		}
		
		// 사람을 이벤트에 등록
		if("add".equals(f.getQuery())) {
			daoPerson.addToSeminar(f.getSelectPerson(), f.getSelectSeminar());
		}
		
		// 사람 목록
		List<VoPerson> personList = daoPerson.getPersonList(f.getSrchWord());
		request.setAttribute("personList", personList);
		// 세미나 목록
		List<VoSeminar> seminarList = daoSeminar.getSeminarList();
		request.setAttribute("seminarList", seminarList);
		
		
		return mapping.findForward("person");
	}
}
