package struts.dao;

import java.util.ArrayList;
import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;

import com.tistory.antop.Person;
import com.tistory.antop.Seminar;

import struts.vo.VoPerson;
import util.HibernateUtil;
import util.Utility;

public class DaoPerson {

	// 사람 등록
	public void insertPerson(String name, String gender) {
		Session sess = HibernateUtil.getCurrentSession();
		Transaction tx = sess.beginTransaction();
		
		Person p = new Person();
		p.setName(name);
		p.setGender(gender);
		
		// 저장(insert)
		sess.save(p);
		
		tx.commit();
		HibernateUtil.closeSession();
	}
	// 사람 삭제
	public void deletePerson(int seq) {
		Session sess = HibernateUtil.getCurrentSession();
		Transaction tx = sess.beginTransaction();
		
		Person p = (Person) sess.load(Person.class, seq);
		sess.delete(p);
		
		tx.commit();
		HibernateUtil.closeSession();
	}
	// 사람 목록
	public List<VoPerson> getPersonList(String srchWord) {

		List<VoPerson> list = new ArrayList<VoPerson>();
		
		Session sess = HibernateUtil.getCurrentSession();
		Transaction tx = sess.beginTransaction();
		
		// 사람 목록
		Criteria crit = sess.createCriteria(Person.class);
		// 정렬
		crit.addOrder(Order.desc("seq"));
		// 검색
		if(Utility.isEmpty(srchWord) == false) {
			crit.add(Restrictions.like("name", "%" + srchWord + "%"));
		}
		
		// Person(Hibernate) -> VoPerson
		List<Person> _list = crit.list();
		int size = _list.size();
		for(int i=0 ; i < size ; i++) {
			Person _p = _list.get(i);
			
			VoPerson _pe = new VoPerson();
			_pe.setSeq(_p.getSeq());
			_pe.setName(_p.getName());
			_pe.setGender(_p.getGender());
			_pe.setSeminarCnt(_p.getSeminars().size());
			
			list.add(_pe);
		}
		
		tx.commit();
		HibernateUtil.closeSession();
		
		return list;
	}
	// 사람을 이벤트에 등록
	public void addToSeminar(int[] selectPerson, int[] selectSeminar) {
		
		Session sess = HibernateUtil.getCurrentSession();
		Transaction tx = sess.beginTransaction();
		
		int personSize = selectPerson.length;
		int seminarSize = selectSeminar.length;
		
		
		for(int i=0 ; i < personSize ; i++) {
			// 맨위의 전체선택 checkbox는 건너뛰기
			if(selectPerson[i] == 0) continue;
			
			Person p = (Person) sess.load(Person.class, selectPerson[i]);
			
			for(int k=0 ; k < seminarSize ; k++) {
				// 맨위의 전체선택 checkbox는 건너뛰기
				if(selectSeminar[k] == 0) continue;
				
				Seminar s = (Seminar) sess.load(Seminar.class, selectSeminar[k]);
				// 사람의 세미나 목록에 추가
				p.addSeminar(s);
			}
			
		}
		
		tx.commit();
		HibernateUtil.closeSession();
	}
}
