package struts.dao;

import java.util.ArrayList;
import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.criterion.Order;

import com.tistory.antop.Seminar;

import struts.vo.VoSeminar;
import util.HibernateUtil;

public class DaoSeminar {

	// 세미나 등록
	public void insertSeminar(String title, String area) {
		Session sess = HibernateUtil.getCurrentSession();
		Transaction tx = sess.beginTransaction();
		
		Seminar s = new Seminar();
		s.setTitle(title);
		s.setArea(area);
		
		// 저장(insert)
		sess.save(s);
		
		tx.commit();
		HibernateUtil.closeSession();
	}
	
	// 세미나 삭제
	public void deleteSeminar(int sid) {
		Session sess = HibernateUtil.getCurrentSession();
		Transaction tx = sess.beginTransaction();
		
		Seminar s = (Seminar) sess.load(Seminar.class, sid);
		
		// 삭제(delete)
		sess.delete(s);
		
		tx.commit();
		HibernateUtil.closeSession();
	}
	
	// 세미나 목록
	public List<VoSeminar> getSeminarList() {
		
		List<VoSeminar> list = new ArrayList<VoSeminar>();
		
		Session sess = HibernateUtil.getCurrentSession();
		Transaction tx = sess.beginTransaction();
		
		// 세미나 목록
		Criteria crit = sess.createCriteria(Seminar.class);
		// 정렬
		crit.addOrder(Order.desc("sid"));
		
		// Seminar(Hibernate) -> VoSeminar
		List<Seminar> _list = crit.list();
		int size = _list.size();
		for(int i=0 ; i < size ; i++) {
			Seminar _s = _list.get(i);
			
			VoSeminar _se = new VoSeminar();
			_se.setSid(_s.getSid());
			_se.setTitle(_s.getTitle());
			_se.setsDate(_s.getsDate());
			_se.setArea(_s.getArea());
			_se.setPersonCnt(_s.getPersons().size());
			
			list.add(_se);
		}
		
		tx.commit();
		HibernateUtil.closeSession();
		
		return list;
	}
}
