package struts.form;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

import util.Utility;

public class FormPerson extends ActionForm {

	// 해야할 작업
	private String query;

	// 등록시 이름
	private String regName;
	// 등록시 성별
	private String regGender;

	// 검색어
	private String srchWord;

	// 수정, 삭제시 필요한 사람 고유 번호
	private int seq;

	// 이벤트 등록시 필요한 필드
	private int[] selectPerson;
	private int[] selectSeminar;
	
	@Override
	public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {

		ActionErrors errors = super.validate(mapping, request);
		if (errors == null)
			errors = new ActionErrors();
		
		// 사람 등록시 검사
		if("regist".equals(query)) {
			// 이름 검사
			if(Utility.isEmpty(regName)) {
				errors.add("name", new ActionMessage("errors.required", "이름"));
			}
			// 성별 검사
			if(Utility.isEmpty(regGender)) {
				errors.add("gender", new ActionMessage("errors.required", "성별"));
			}
		}
		
		// return
		if (errors == null)
			return null;
		if (errors.isEmpty())
			return null;

		return errors;
	}

	public String getQuery() {
		return query;
	}

	public void setQuery(String query) {
		this.query = query;
	}

	public String getRegName() {
		return regName;
	}

	public void setRegName(String regName) {
		this.regName = regName;
	}

	public String getRegGender() {
		return regGender;
	}

	public void setRegGender(String regGender) {
		this.regGender = regGender;
	}

	public String getSrchWord() {
		return srchWord;
	}

	public void setSrchWord(String srchWord) {
		this.srchWord = srchWord;
	}

	public int getSeq() {
		return seq;
	}

	public void setSeq(int seq) {
		this.seq = seq;
	}

	public int[] getSelectPerson() {
		return selectPerson;
	}

	public void setSelectPerson(int[] selectPerson) {
		this.selectPerson = selectPerson;
	}

	public int[] getSelectSeminar() {
		return selectSeminar;
	}

	public void setSelectSeminar(int[] selectSeminar) {
		this.selectSeminar = selectSeminar;
	}

}
