package struts.form;

import java.util.Date;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

import util.Utility;

public class FormSeminar extends ActionForm {

	// 처리
	private String query;
	
	// 세미나명
	private String title;
	// 세미나 날짜(귀찮아서 걍 자동생성... -_-)
	private Date sDate = new Date();
	// 세미나 장소
	private String area;
	
	// 삭제시 사용할 고유 번호
	private int sid;
	
	@Override
	public ActionErrors validate(ActionMapping mapping,	HttpServletRequest request) {
	
		ActionErrors errors = super.validate(mapping, request);
		if (errors == null)
			errors = new ActionErrors();
		
		// 세미나 등록시 검사
		if("regist".equals(query)) {
			// 제목
			if(Utility.isEmpty(title)) {
				errors.add("title", new ActionMessage("errors.required", "세미나명"));
			}
			// 장소
			if(Utility.isEmpty(area)) {
				errors.add("area", new ActionMessage("errors.required", "장소"));
			}
		}
		
		// return
		if (errors == null)
			return null;
		if (errors.isEmpty())
			return null;

		return errors;
	}

	public String getQuery() {
		return query;
	}

	public void setQuery(String query) {
		this.query = query;
	}

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public Date getsDate() {
		return sDate;
	}

	@SuppressWarnings("unused")
	private void setsDate(Date sDate) {
		this.sDate = sDate;
	}

	public String getArea() {
		return area;
	}

	public void setArea(String area) {
		this.area = area;
	}

	public int getSid() {
		return sid;
	}

	public void setSid(int sid) {
		this.sid = sid;
	}
	
}
